PROGRAM main
    USE mpi
    IMPLICIT NONE
    INTEGER, PARAMETER :: MYP = SELECTED_REAL_KIND(12)
    INTEGER, PARAMETER :: size = 5, root = 1
    INTEGER :: myrank, realtype, error
    REAL(KIND=MYP), DIMENSION(size) :: array

    array = 0.0_MYP

    CALL MPI_Init(error)
    CALL MPI_Comm_rank(MPI_COMM_WORLD,myrank,error)
    IF (myrank == root) THEN
        OPEN (11,FILE="Programs/reals.input",ACTION="READ")
        READ (11,*) array
        CLOSE(11)
    END IF
    CALL MPI_Type_create_f90_real(12,MPI_UNDEFINED,realtype,error)
    CALL MPI_Bcast(array,size,realtype,root,MPI_COMM_WORLD,error)
    WRITE (*,"('Processor ',I0,' now has data',100(1X,F0.3))") myrank,array
    CALL MPI_Finalize(error)
END PROGRAM main
